<?php

  class ot_postforskottsavgift {
    var $title, $output;
    
    function ot_postforskottsavgift() {
      
      $this->code = 'ot_postforskottsavgift';
    
      $this->moduleinfo = array(
        'name'        => 'Posten AB - Postfrskottsavgift (Inrikes)',
        'description' => 'Den hr modulen specificerar eventuell postfrskottsavgift och gr en proportionell momsrkning om varor omfattas av olika skattesatser.',
        'changelog'   => array(
          //'200X-XX-XX' => '*/+/- Din changelog text.',
          '2009-06-08' => '* Fel i momsfunktion tgrdad',
          '2009-06-08' => '+ Mjlighet till 25% standardmoms',
          '2008-03-27' => '+ Bttre metod vid installering rensar gamla spr av modulen. // Tim',
          '2008-03-27' => '+ Alternativ metod fr bttre kompatibilitet med andra bidrag. // Tim',
          '2008-03-27' => '* Optimering av kod. // Tim',
          '2007-12-16' => '* Uppdaterad med Postens nya priser 2008. // Tim',
          '2007-12-16' => '+ Avgiftsmoms i momstotalen saknades. // Tim',
          '2007-12-12' => '* Finslipning av PHP kod. (Pverkar ej funktionalitet) // Tim',
          '2007-06-17' => '- Tog bort std fr tidigare versioner. // Tim',
          '2007-06-17' => '* Inga justeringar behvs lngre i osCommerce fr modul. // Tim',
          '2007-06-08' => '* Problem med moms tgrdat. // Tim',
          '2007-06-08' => '+ Std fr osC konfiguration att visa pris exkl moms. // Tim',
          '2007-05-12' => '* Uppdaterad med Postens ordinarie priser. // Tim',
          '2007-05-12' => '* Bortglmd variabel fick namnet tillrtta. // Tim',
          '2007-05-02' => '* Felberkning i bakgrundskalkylen korrigerad. // Tim',
          '2007-04-25' => '+ Std fr nya alternativ i Postens leveransmoduler. // Tim',
          '2007-04-25' => '+ Subtraktion av eventuell Rek avgift. // Tim',
          '2007-04-25' => '* Kompatibel med nyare versioner av leveransmoduler. // Tim',
          '2007-04-05' => '* Programlnk uppdaterad. // Tim',
          '2007-04-04' => '+ Informationsruta fr modul. // Tim',
        ),
        'author'      => 'T. Almroth',
        'platform'    => 'osCommerce 2.2-MS2',
        'homepage'    => 'http://www.tim-international.net',
        'support'     => 'http://www.oscforum.se',
      );
      
      if (basename($_SERVER['PHP_SELF']) == 'modules.php') {
        
        $this->title     = '[TiM\'s osC Modules] Version '. key($this->moduleinfo['changelog']) .' :: '. $this->moduleinfo['name'];
        
        $this->description = $this->moduleinfo['description'] . '<br><br>
          <script language="javascript">
          function changeloggg() {
            alert(\'* = ndrat\\\\n+ = Tillagt\\\n- = Borttaget\\\n\\\n' . implode('\\\n', array_reverse($this->moduleinfo['changelog'])) . '\')
          }
          </script>
          <table border="0" cellpadding="2" cellspacing="0" bgcolor="#F0F1F1" align="center">
            <tr class"dataTableHeadingRow">
              <td colspan="2" bgcolor="cecbce" class="dataTableHeadingContent" nowrap><strong>Om modulen</strong></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Modulnamn: </strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['name'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Skapad av: </strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['author'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Plattform:</strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['platform'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Modulversion:</strong></td>
              <td class="dataTableContent">'. key($this->moduleinfo['changelog']) .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>ndringslogg:</strong></td>
              <td class="dataTableContent"><a href="javascript:changeloggg();">&lt;Klicka f&ouml;r att se&gt;</a></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Programlnk: </strong></td>
              <td class="dataTableContent"><a href="'. $this->moduleinfo['homepage'] .'" target="_blank">'. substr($this->moduleinfo['homepage'], 0, 18) .'...</a></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Supportlnk:</strong></td>
              <td class="dataTableContent"><a href="'. $this->moduleinfo['support'] .'" target="_blank">'. substr($this->moduleinfo['support'], 0, 18) .'...</a></td>
            </tr>
          </table>';
        
      } else {
        
        $this->title = $this->moduleinfo['name'];
      }
      
      $this->enabled = ((MODULE_TOTAL_POSTFORSKOTTSAVGIFT_STATUS == 'Ja') ? true : false);
      $this->sort_order = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_SORT_ORDER;
      $this->output = array();
    }
    
    function process() {
      global $order, $shipping, $payment, $currencies;
      
      if ($order->delivery['country']['iso_code_2'] != 'SE') return false;
      
      if ($payment != 'postforskott') return false;
      
      if ($shipping['id'] == 'inrikespaket_dpdforetagspaket0900') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET0900_FEE;
      if ($shipping['id'] == 'inrikespaket_dpdforetagspaket1200') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET1200_FEE;
      if ($shipping['id'] == 'inrikespaket_dpdforetagspaket1600') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET1600_FEE;
      if ($shipping['id'] == 'inrikespaket_postpaket') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_POSTPAKET_FEE;
      if ($shipping['id'] == 'inrikespaket_hempaket') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_HEMPAKET_FEE;
      if ($shipping['id'] == 'inrikesbrev_1aklassbrev') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_1AKLASSBREV_FEE;
      if ($shipping['id'] == 'inrikesbrev_1aklassbrevrek') $cod_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_1AKLASSBREV_FEE;
      
      if ($cod_cost) {
        
        // Subtrahera Rek avgift
        if ($shipping['id'] == 'inrikesbrev_1aklassbrevrek') {
          
          $rek_cost = MODULE_TOTAL_POSTFORSKOTTSAVGIFT_REK_FEE;
          
          if (MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_TYPE == 'Standard') {
            $rek_tax = -$this->calculate_and_input_proportional_tax(-$rek_cost);
          } else {
            $rek_tax_rate = tep_get_tax_rate(MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
            $rek_tax_description = tep_get_tax_description(MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
            
            $rek_tax = -tep_calculate_tax($rek_cost, $rek_tax_rate);
            $order->info['tax'] += $rek_tax;
            $order->info['tax_groups']["$rek_tax_description"] += $rek_tax;
          }
          
          $order->info['total'] -= $rek_cost + $rek_tax;
          
          $this->output[] = array(
            'title' => MODULE_TOTAL_POSTFORSKOTTSAVGIFT_REK_LABEL,
            'text' =>  $currencies->format(((DISPLAY_PRICE_WITH_TAX == 'true') ? -($rek_cost + $rek_tax) : -($rek_cost)), true, $order->info['currency'], $order->info['currency_value']),
            'value' => ((DISPLAY_PRICE_WITH_TAX == 'true') ? -($rek_cost + $rek_tax) : -($rek_cost))
          );
        }
        
        if (MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_TYPE == 'Standard') {
          $cod_tax_rate = tep_get_tax_rate(MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
          $cod_tax_description = tep_get_tax_description(MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
          
          $cod_tax = tep_calculate_tax($cod_cost, $cod_tax_rate);
          $order->info['tax'] += $cod_tax;
          $order->info['tax_groups']["$cod_tax_description"] += $cod_tax;
          
        } else {
          $cod_tax = $this->calculate_and_input_proportional_tax($cod_cost);
        }
        
        if (MODULE_TOTAL_POSTFORSKOTTSAVGIFT_ALT_OPTION == 'Ja') {
          
          $order->info['shipping_cost'] += $cod_cost + $cod_tax;
          $order->info['total'] += $cod_tax;
          
        } else {
          
          $order->info['total'] += ($cod_cost + $cod_tax);
          
           $this->output[] = array(
            'title' => MODULE_TOTAL_POSTFORSKOTTSAVGIFT_LABEL,
            'text' =>  $currencies->format(((DISPLAY_PRICE_WITH_TAX == 'true') ? $cod_cost + $cod_tax : $cod_cost), true, $order->info['currency'], $order->info['currency_value']),
            'value' => ((DISPLAY_PRICE_WITH_TAX == 'true') ? $cod_cost + $cod_tax : $cod_cost)
          );
        }
      }
    }
    
    function calculate_and_input_proportional_tax($fee=0) {
      global $order;
      
      // Step through every product in shopping cart
        foreach ($order->products as $product) {
          
        // Summarize the gross cost for all products, group by tax group
          $tax_groups[$product['tax_description']]['gross_sum'] += $product['qty'] * ($product['final_price']);
          
        // Summarize the tax cost for all products, group by tax group
          $tax_groups[$product['tax_description']]['tax_rate'] = $product['tax'];
          
        // Summarize the total gross cost for all products, no matter which tax groups
          $gross_total += $product['qty'] * $product['final_price'];
          
        // Summarize the total gross cost for all products, no matter which tax groups
          $tax_total += $product['qty'] * $product['final_price'] * $product['tax'] / 100;
        }
        
      // Step through each tax group
        foreach ($tax_groups as $tax_description => $tax_info) {
        
        // Get proportional tax for current tax group
          $taxgroup_tax = $fee * ($tax_info['gross_sum'] / $gross_total) * ($tax_info['tax_rate'] / 100);
          
        // Insert tax ammont into global variable
          $order->info['tax_groups'][$tax_description] += $taxgroup_tax;
          $order->info['tax'] += $taxgroup_tax;
          
        // Summarize the total tax cost for the fee
          $fee_tax += $taxgroup_tax;
        }
        
      return $fee_tax;
    }
    
    function check() {
      if (!isset($this->check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_STATUS'");
        $this->check = tep_db_num_rows($check_query);
      }
      return $this->check;
    }
    
    function install() {
      $this->remove();
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Funktionen aktiverad?', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_STATUS', 'Ja', 'Vill du berkna och specificera eventuell postfrskottsavgift?', '6', '1', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('1:a klass brev', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_1AKLASSBREV_FEE', '40', 'Ange postfrskottsavgift exkl moms.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('DPD Fretagspaket 09.00', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET0900_FEE', '90', 'Ange postfrskottsavgift exkl moms.', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('DPD Fretagspaket 12.00', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET1200_FEE', '90', 'Ange postfrskottsavgift exkl moms.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('DPD Fretagspaket 16.00', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET1600_FEE', '90', 'Ange postfrskottsavgift exkl moms.', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Postpaket', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_POSTPAKET_FEE', '42', 'Ange postfrskottsavgift exkl moms.', '6', '6', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Hempaket', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_HEMPAKET_FEE', '90', 'Ange postfrskottsavgift exkl moms.', '6', '7', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Rek (Subtraktionsbelopp)', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_REK_FEE', '40', 'Ange Rek-avgift exkl moms. Denna avgift kommer subtraheras om leveransen innefattar 1:a klass brevsndning med Rek.', '6', '8', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Momsfunktion', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_TYPE', 'Variabel', 'Ange nskad momsfunktion ex. Standard fr att sjlv ange momsklass nedan eller Variabel fr att frakten regelriktigt skall rva momsen frn varorna (OBS! krver TiM\'s ordertotal-moduler).', '6', '4', 'tep_cfg_select_option(array(\'Standard\', \'Variabel\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Momsklass', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_CLASS', '0', 'Ange momsklass fr fraktavgiften.', '6', '5', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Anvnd alternativ metod?', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_ALT_OPTION', 'Nej', 'Specificera inte avgiften utan lgg till den p fraktkostnaden. Fr kad kompatibilitet med bidrag som inte stder 3e part moduler i ordertotalen. Obs! Modulen mste visas FRE modulen fr fraktspecifikation.', '6', '8', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sortering', 'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_SORT_ORDER', '9', 'Ange plats i modulernas sorteringsorning.', '6', '9', now())");
    }
    
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
    
    function keys() {
      return array(
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_STATUS',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_1AKLASSBREV_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET0900_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET1200_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_DPDFORETAGSPAKET1600_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_POSTPAKET_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_HEMPAKET_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_REK_FEE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_TYPE',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_TAX_CLASS',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_ALT_OPTION',
        'MODULE_TOTAL_POSTFORSKOTTSAVGIFT_SORT_ORDER'
      );
    }
  }
  
?>