<?php

  class postforskott {
    var $code, $title, $description, $enabled, $module;
    
    function postforskott() {
      
      $this->code = 'postforskott';
      
      $this->moduleinfo = array(
        'name'        => 'Posten AB - Postfrskott (Inrikes)',
        'description' => 'Den hr modulen tillter dina kunder att vlja Postens postfrskott som betalningsalternativ om de har valt leverans via Posten AB.',
        'changelog'   => array(
          //'200X-XX-XX' => '*/+/- Din changelog text.',
          '2010-01-16' => '+ Alternativet kan ven visas vid andra fraktmoduler n Postens. // Tim',
          '2010-01-13' => '+ Std fr ikoner i Fast Easy Checkout. // Tim',
          '2010-01-12' => '+ Std fr ikoner. // Tim',
          '2008-10-15' => '+ Std fr beskrivning under metodvalet. // Tim',
          '2008-08-07' => '+ Gm alternativet vid Inrikesbrev: Ekonomibrev // oscforum.se:lolatroll',
          '2007-12-12' => '* Finslipning av PHP kod. (Pverkar ej funktionalitet) // Tim',
          '2007-06-17' => '- Tog bort std fr tidigare versioner. // Tim',
          '2007-06-17' => '* Inga justeringar behvs lngre i osCommerce fr modul. // Tim',
          '2007-06-10' => '* Ruta fr sorteringsordning korrigerad. // Tim',
          '2007-05-12' => '* Engelsk sprkfil korrigerad. // Tim',
          '2007-04-25' => '* Std fr nyare versioner av Posten AB leveransmoduler. // Tim',
          '2007-04-25' => '+ Begrnsning till endast inrikes bestllningar. // Tim',
          '2007-04-05' => '* Programlnk uppdaterad. // Tim',
          '2007-04-04' => '+ Informationsruta fr modul. // Tim',
        ),
        'author'      => 'T. Almroth',
        'platform'    => 'osCommerce 2.2-MS2',
        'homepage'    => 'http://www.tim-international.net',
        'support'     => 'http://www.oscforum.se',
      );
    
      if (basename($_SERVER['PHP_SELF']) == 'modules.php') {
        
        $this->title     = '[TiM\'s osC Modules] Version '. key($this->moduleinfo['changelog']) .' :: '. $this->moduleinfo['name'];
        
        $this->description = $this->moduleinfo['description'] . '<br><br>
          <script language="javascript">
          function changeloggg() {
            alert(\'* = ndrat\\\\n+ = Tillagt\\\n- = Borttaget\\\n\\\n' . implode('\\\n', array_reverse($this->moduleinfo['changelog'])) . '\')
          }
          </script>
          <table border="0" cellpadding="2" cellspacing="0" bgcolor="#F0F1F1" align="center">
            <tr class"dataTableHeadingRow">
              <td colspan="2" bgcolor="cecbce" class="dataTableHeadingContent" nowrap><strong>Om modulen</strong></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Modulnamn: </strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['name'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Skapad av: </strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['author'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Plattform:</strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['platform'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Modulversion:</strong></td>
              <td class="dataTableContent">'. key($this->moduleinfo['changelog']) .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>ndringslogg:</strong></td>
              <td class="dataTableContent"><a href="javascript:changeloggg();">&lt;Klicka f&ouml;r att se&gt;</a></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Programlnk: </strong></td>
              <td class="dataTableContent"><a href="'. $this->moduleinfo['homepage'] .'" target="_blank">'. substr($this->moduleinfo['homepage'], 0, 18) .'...</a></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Supportlnk:</strong></td>
              <td class="dataTableContent"><a href="'. $this->moduleinfo['support'] .'" target="_blank">'. substr($this->moduleinfo['support'], 0, 18) .'...</a></td>
            </tr>
          </table>';
      } else {
        
        $this->title = $this->moduleinfo['name'];
      }
      
      $this->enabled = ((MODULE_PAYMENT_POSTEN_STATUS == 'Ja') ? true : false);
      $this->sort_order = MODULE_PAYMENT_POSTEN_SORT_ORDER;
      
      if ((int)MODULE_PAYMENT_POSTEN_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_POSTEN_ORDER_STATUS_ID;
      }
    }
    
    function update_status() {
    }
    
    function javascript_validation() {
    }
    
    function selection() {
      global $order, $shipping;
    
      $delivery_country = $order->delivery['country']['iso_code_2'];
      if ($delivery_country != 'SE') return false;
      
      // Hide from non-triggeringering shipping modules
      if (MODULE_PAYMENT_POSTEN_TRIGGERING_MODULES != '') {
        if (!in_array(substr($shipping['id'], 0, strrpos($shipping['id'], '_')), explode(';', MODULE_PAYMENT_POSTEN_TRIGGERING_MODULES))) {
          return false;
        }
      }
      
      // Hide from "inrikesbrev_ekonomibrev" by lolatroll
      if ($shipping['id'] == 'inrikesbrev_ekonomibrev') {
        return false;
      }
      
      // Hide from virtual products
      if ($order->content_type == 'virtual') {
        return false;
      }
      
      // Set pages to recceive the icon instead of the text title
      $payment_method_pages = array(
        'osCommerce Checkout' => 'checkout_payment.php',
        'Fast Easy Checkout' => 'checkout_shipping.php',
        // 'One Page Checkout' => 'checkout.php' // Warning: Sets image html code as payment title in order confirmation. Do not use!
      );
      
      // Output option
      if (in_array(basename($_SERVER['PHP_SELF']), $payment_method_pages)) {
        return array(
          'id' => $this->code,
          'module' => ((MODULE_PAYMENT_POSTEN_ICON != '') ? tep_image(MODULE_PAYMENT_POSTEN_ICON, MODULE_PAYMENT_POSTEN_TEXT_TITLE) : MODULE_PAYMENT_POSTEN_TEXT_TITLE) . ((MODULE_PAYMENT_POSTEN_TEXT_DESCRIPTION != '') ? '<br /><span style="font-weight: normal;">'. MODULE_PAYMENT_POSTEN_TEXT_DESCRIPTION .'</span>' : false)
        );
      } else {
        return array(
          'id' => $this->code,
          'module' => MODULE_PAYMENT_POSTEN_TEXT_TITLE
        );
      }
    }
    
    function pre_confirmation_check() {
    }
    
    function confirmation() {
    }
    
    function process_button() {
    }
    
    function before_process() {
    }
    
    function after_process() {
    }
    
    function output_error() {
    }
    
    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_POSTEN_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }
    
    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Tjnsten aktiverad?', 'MODULE_PAYMENT_POSTEN_STATUS', 'Ja', 'Vill du erbjuda postfrskott via Posten AB som betalningsalternativ?', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Ikon', 'MODULE_PAYMENT_POSTEN_ICON', '', 'Om du vill visa en ikon istllet fr ett textalternativ, ange webbskvg ex. /images/myicon.gif', '6', '1', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Modulbegrnsning', 'MODULE_PAYMENT_POSTEN_TRIGGERING_MODULES', 'inrikesbrev;inrikespaket', 'Begrnsa alternativet till nedan angivna fraktmodul ID (separera med semikolon), eller lmna fltet blankt fr att alltid visa alternativet.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Stt orderstatus', 'MODULE_PAYMENT_POSTEN_ORDER_STATUS_ID', '0', 'Byt till fljande status fr ordrar gjorda med det hr betalningsalternativet.', '6', '3', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sortering', 'MODULE_PAYMENT_POSTEN_SORT_ORDER', '0', 'Ange plats i modulernas sorteringsorning.', '6', '4', now())");
    }
    
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
    
    function keys() {
      return array(
        'MODULE_PAYMENT_POSTEN_STATUS',
        'MODULE_PAYMENT_POSTEN_ICON',
        'MODULE_PAYMENT_POSTEN_TRIGGERING_MODULES',
        'MODULE_PAYMENT_POSTEN_ORDER_STATUS_ID',
        'MODULE_PAYMENT_POSTEN_SORT_ORDER'
      );
    }
  }
  
?>